/**
 * $Id: Actor.java,v 1.24 2002/08/21 01:36:46 stepha Exp $
 *
 * This is the main Actor class.
 */

package salsa.language;

import java.lang.reflect.Method;

public class Actor implements java.io.Serializable {
   public transient UniversalActorState actorState;

   public Actor() {
      //actorState's constructor should be called by the parent class
      //such that it extends properly
      ;
   }

   public void send(Message message) {
      actorState.send(message);
   }

   synchronized void process(Message message) {
      actorState.process(message);
   }

   public String toString() {
      return getClass().getName()+":"+super.toString();
   }

   public String getName() {
      return actorState.getName();
   }

   /**
    * The Salsa compiler should always generate code that uses the
    * version of this method:
    *       send(Message message)
    *
    * The following methods demonstrate the type of code that gets
    * generated by the SALSA compiler.
    */

    // The six overloaded send(...) methods below were deleted
    // because as stated above they are never invoked by compiler
    // generated code. In the future certain developers will have
    // limits placed on how many times they are allowed to
    // overload a single method in a given class.
    //                                              -- abe


}
