package salsa.language;

import java.io.*;

public class MigrationWrapper implements java.io.Serializable {
	private UniversalActor actor;
	private UniversalActorState state;


	public MigrationWrapper(UniversalActor ua, UniversalActorState uas) {
		actor = ua;
		state = uas;
	}

	public UniversalActor getActor() {
		return actor;
	}

	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		//set the actorState's parent field to null, such that it doesnt get duplicated
		//while being sent over the connection
		out.writeObject(actor);
		out.writeObject(state);
		out.flush();
	}

	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
		//read the actor and its state
		actor = (UniversalActor) in.readObject();
		state = (UniversalActorState) in.readObject();

		//update the actor's references
		actor.actorState = state;
		state.self = actor;

		// Start the new thread.
		state.setName( state.getClass().getName() );
		state.start();

	}
}
