package language;

import salsa.language.*;

public class Continuation extends Actor{

    public int i(int n){ return ++n; }
    public int d(int n){ return n*2; }
    public int m(int n1, int n2) { return n1*n2; }
    public int a(int n1, int n2) { return n1+n2; }
    public int p(int n){ System.out.print(n+" "); return n;}

    public static void main(String[] args){
	Continuation c = new Continuation();

	// i(0)->p->d->p->i->p->d->p->i->p->m(token,2)->p->a(3,token)->p;
	{
	    Actor[] targets = {c,c,c,c,c,c,c,c,c,c,c,c,c,c};
	    String[] methodNames = {"i","p",
				    "d","p",
				    "i","p",
				    "d","p",
				    "i","p",
				    "m","p",
				    "a","p"};
	    Object[][] arguments = { { new Integer(0) },
				     { null },
				     { null },
				     { null },
				     { null },
				     { null },
				     { null },
				     { null },
				     { null },
				     { null },
				     { null, new Integer(2) },
				     { null },
				     { new Integer(3), null },
				     { null }};
	    int [] tokens = {-1,0,0,0,0,0,0,0,0,0,0,0,1,0};
	    try {
		c.send
		    (Message.createMessage
		     (c,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		System.err.println(nsme);
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}
    }
}
