package messenger;

import salsa.language.*;

public class Letter extends Actor{
    Sender sender;
    String name;

    Letter(Sender sender, String name){
	this.sender = sender;
	this.name = name;
    }
    
    public void retry(Recipient recipient){
	if (recipient != null){
	    {
		// recipient:process(self)->self:retry;
		Actor[] targets = { recipient, this };
		String[] methodNames = { "process", "retry" };
		Object[][] arguments = { { this },
					 { null }
		};
		int [] tokens = {-1, 0};
		try {
		    recipient.send
			(Message.createMessage
			 (this,
			  targets,
			  methodNames,
			  arguments,
			  tokens));
		} catch (NoSuchMessageException nsme){
		    System.err.println(nsme);
		    nsme.printStackTrace();
		} catch (MessageCreationException mce){
		    System.err.println("SALSA Internal Error:"+
				       mce.getMessage());
		}   
	    }
	}
    }
    
    public void failed(Recipient recipient){
	if (recipient != null){
	    try {
		sleep(1000);
	    } catch (InterruptedException ie){
	    }
	    
	    // recipient:process(self)->self:failedTwice;
	    {
		Actor[] targets = { recipient, this };
		String[] methodNames = { "process", "failedTwice" };
		Object[][] arguments = { { this },
					 { null }
		};
		int [] tokens = {-1, 0};
		try {
		    recipient.send
			(Message.createMessage
			 (this,
			  targets,
			  methodNames,
			  arguments,
			  tokens));
		} catch (NoSuchMessageException nsme){
		    System.err.println(nsme);
		    nsme.printStackTrace();
		} catch (MessageCreationException mce){
		    System.err.println("SALSA Internal Error:"+
				       mce.getMessage());
		}
	    }
	}
    }

    public void failedTwice(Recipient recipient){
	if (recipient != null){
	    // sender:log(this);
	    {
		Actor[] targets = { sender };
		String[] methodNames = { "log" };
		Object[][] arguments = { { this } };
		int [] tokens = {-1};
		try {
		    sender.send
			(Message.createMessage
			 (sender,
			  targets,
			  methodNames,
			  arguments,
			  tokens));
		} catch (NoSuchMessageException nsme){
		    System.err.println(nsme);
		    nsme.printStackTrace();
		} catch (MessageCreationException mce){
		    System.err.println("SALSA Internal Error:"+
				       mce.getMessage());
		}   
	    }
	}
    }

    public String toString(){
	return name;
    }
}
