package messenger;

import salsa.language.*;

public class Sender extends Actor{
    public static void main(String[] args){
	Sender sender = new Sender();
	Letter letter = new Letter(sender, "Try Once Messenger");
	Recipient recipient = new Recipient();

	// recipient:process(letter);
	{
	    Actor[] targets = { recipient };
	    String[] methodNames = { "process" };
	    Object[][] arguments = { { letter } };
	    int [] tokens = {-1};
	    try {
		recipient.send
		    (Message.createMessage
		     (sender,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		System.err.println(nsme);
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}

	recipient = new Recipient();
	letter = new Letter(sender, "Try Forever Messenger");
	// recipient:process(letter) -> letter:retry;
	{
	    Actor[] targets = { recipient, letter };
	    String[] methodNames = { "process", "retry" };
	    Object[][] arguments = { { letter },
				     { null }
	    };
	    int [] tokens = {-1, 0};
	    try {
		recipient.send
		    (Message.createMessage
		     (sender,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		System.err.println(nsme);
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}

	recipient = new Recipient();
	letter = new Letter(sender, "Try Twice Messenger");
	// recipient:process(letter) -> letter:failed;
	{
	    Actor[] targets = { recipient, letter };
	    String[] methodNames = { "process", "failed" };
	    Object[][] arguments = { { letter },
				     { null }
	    };
	    int [] tokens = {-1, 0};
	    try {
		recipient.send
		    (Message.createMessage
		     (sender,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		System.err.println(nsme);
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}
    }
    public void log(Letter letter){
	System.err.println(letter + " reported failure.");
    }
}
