package multicast;

import salsa.language.*;

public class AcknowledgedMulticast extends Actor{
    SimpleActor[] actors;
    long initialTime;
    AcknowledgedMulticast(SimpleActor[] actors){
	this.actors = actors;
    }
    public long go(Message currentMessage){
        initialTime = System.currentTimeMillis();
// 	// {actors:m()}->ack() is equivalent to:
// 	// {actors[0]:m();actors[1]:m();...;actors[n-1]:m()}->ack();
// 	// cvarela: probably better to use Cast...
// 	// instead of "->currentContinuation", use "->continue"(?)
//         {actors:m()}->ack()->currentContinuation;
	try {
	    MessageGroup messageGroup = null;
	    {
		Actor[] targets = actors;
		String[] methodNames = new String[actors.length];
		int[] tokenPositions = new int[actors.length];
		Object [][] arguments = new Object[actors.length][];
		for (int i = 0; i< actors.length; i++){
		    methodNames[i] = "m";
		    tokenPositions[i] = -1;
		    arguments[i] = new Object[0];
		}
		Message continuation = null;
		{
		    //  -> ack()->currentContinuation
		    Actor[] continuationTargets = { this };
		    String[] continuationMethodNames = { "ack" };
		    Object[][] continuationArguments = { { } };
		    int[] continuationTokens = {-1};
		    continuation =
			Message.createMessage
			(this,
			 continuationTargets,
			 continuationMethodNames,
			 continuationArguments,
			 continuationTokens);
		    continuation.setLastContinuation
			(currentMessage.getContinuation());
		    currentMessage.setContinuation(null);
		} 
		messageGroup =
		    MessageGroup.createMessageGroup
		    (this,
		     targets,
		     methodNames,
		     arguments,
		     tokenPositions,
		     continuation);
	    }
	    //  messageGroup:process();
	    {
		Actor[] targets = {messageGroup};
		String[] methodNames = {"process"};
		Object[][] arguments = { {} };
		int [] tokens = {-1};
		    messageGroup.send
			(Message.createMessage
			 (this,
			  targets,
			  methodNames,
			  arguments,
			  tokens));
	    }
	} catch (NoSuchMessageException nsme){
	    nsme.printStackTrace();
	} catch (MessageCreationException mce){
	    System.err.println("SALSA Internal Error:"+
			       mce.getMessage());
	}   
	return 0;  // will be discarded, since continuation is null.
    }
    public long ack(){
	return System.currentTimeMillis() - initialTime;
    }
    public static void main(String[] args){
	StandardOutput standardOutput = new StandardOutput();
	int howMany = Integer.parseInt(args[0]);
	SimpleActor[] actors = new SimpleActor[howMany];
	for (int i = 0; i< howMany; i++){
	    actors[i] = new SimpleActor();
	}
	AcknowledgedMulticast director = new AcknowledgedMulticast(actors);
// //         director:go() -> standardOutput:println("Multicast took: "+token+" ms.");
//         standardOutput:print("Time for acknowledged multicast: ") ->
//         director:go() ->
// 	standardOutput:print ->
// 	standardOutput:println(" ms.");
	{
	    Actor[] targets = { standardOutput, director,
	                        standardOutput, standardOutput};
	    String[] methodNames = { "print", "go",
	                             "print", "println"};
	    Object[][] arguments = { { "Time for acknowledged multicast: " },
				     { null },  // for Message
				     { null },
				     { " ms." }
	    };
	    int [] tokens = {-1, -2, 0, -1};  // -2 for Message.
	    try {
		standardOutput.send
		    (Message.createMessage
		     (director,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}
    }
}
