package multicast;

import salsa.language.*;

public class GlobalKnowledgeMulticast extends Actor{

    AwareActor[] actors;
    long initialTime;

    GlobalKnowledgeMulticast(AwareActor[] actors){
	this.actors = actors;
    }

    public long go(Message currentMessage){
	initialTime = System.currentTimeMillis();

// 	join {actors:m()} -> join {actors:ok()} -> ack() ->currentContinuation;

	try {
	    MessageGroup messageGroup = null;
	    {
		Actor[] targets = actors;
		String[] methodNames = new String[actors.length];
		int[] tokenPositions = new int[actors.length];
		Object[][] arguments = new Object[actors.length][];
		for (int i = 0; i< actors.length; i++){
		    methodNames[i] = "m";
		    tokenPositions[i] = -1;
		    arguments[i] = new Object[0];
		}
		Message continuation = null;
		{
		    // -> join {actors:ok()} -> ack() ->currentContinuation;
		    MessageGroup messageGroup2 = null;
		    {
			Actor[] targets2 = actors;
			String[] methodNames2 = new String[actors.length];
			int[] tokenPositions2 = new int[actors.length];
			Object[][] arguments2 = new Object[actors.length][];
			for (int i = 0; i< actors.length; i++){
			    methodNames2[i] = "ok";
			    tokenPositions2[i] = -1;
			    arguments2[i] = new Object[0];
			}
			Message continuation2 = null;
			{
			    //  -> ack()->currentContinuation
			    Actor[] continuationTargets = { this };
			    String[] continuationMethodNames = { "ack" };
			    Object[][] continuationArguments = { { } };
			    int[] continuationTokens = {-1};
			    continuation2 =
				Message.createMessage
				(this,
				 continuationTargets,
				 continuationMethodNames,
				 continuationArguments,
				 continuationTokens);
			    continuation2.setLastContinuation
				(currentMessage.getContinuation());
			    currentMessage.setContinuation(null);
			} 
			messageGroup2 =
			    MessageGroup.createMessageGroup
			    (this,
			     targets2,
			     methodNames2,
			     arguments2,
			     tokenPositions2,
			     continuation2);
		    }
		    Actor[] continuationTargets = { messageGroup2 };
		    String[] continuationMethodNames = { "process" };
		    Object[][] continuationArguments = { { } };
		    int[] continuationTokens = {-1};
		    continuation =
			Message.createMessage
			(this,
			 continuationTargets,
			 continuationMethodNames,
			 continuationArguments,
			 continuationTokens);
		}
		messageGroup =
		    MessageGroup.createMessageGroup
		    (this,
		     targets,
		     methodNames,
		     arguments,
		     tokenPositions,
		     continuation);
	    }
	    //  messageGroup:process();
	    {
		Actor[] targets = {messageGroup};
		String[] methodNames = {"process"};
		Object[][] arguments = { {} };
		int [] tokens = {-1};
		    messageGroup.send
			(Message.createMessage
			 (this,
			  targets,
			  methodNames,
			  arguments,
			  tokens));
	    }
	} catch (NoSuchMessageException nsme){
	    nsme.printStackTrace();
	} catch (MessageCreationException mce){
	    System.err.println("SALSA Internal Error:"+
			       mce.getMessage());
	}   
	return 0;  // will be discarded, since continuation is null.
    }

    public long ack(){
	return System.currentTimeMillis() - initialTime;
    }

    public static void main(String args[]){
	StandardOutput standardOutput = new StandardOutput();
	int howMany = Integer.parseInt(args[0]);
	AwareActor[] actors = new AwareActor[howMany];
	for (int i = 0; i< howMany; i++){
	    actors[i] = new AwareActor();
	}
	GlobalKnowledgeMulticast director = 
	    new GlobalKnowledgeMulticast(actors);
// //         director:go() -> standardOutput:println("Multicast took: "+token+" ms.");
//         standardOutput:print("Time for global knowledge multicast: ") ->
//         director:go() ->
// 	standardOutput:print ->
// 	standardOutput:println(" ms.");
	{
	    Actor[] targets = { standardOutput, director,
	                        standardOutput, standardOutput};
	    String[] methodNames = { "print", "go",
	                             "print", "println"};
	    Object[][] arguments = { { "Time for global knowledge multicast: " },
				     { null },  // for Message
				     { null },
				     { " ms." }
	    };
	    int [] tokens = {-1, -2, 0, -1};  // -2 for Message.
	    try {
		standardOutput.send
		    (Message.createMessage
		     (director,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}
    }
}
