package multicast;

import salsa.language.*;

public class Multicast extends Actor{
    SimpleActor[] actors;
    Multicast(SimpleActor[] actors){
	this.actors = actors;
    }
    public long go(){
	long initialTime = System.currentTimeMillis();
	for (int i = 0; i< actors.length; i++){
	    //	    actors[i]:m();
	    {
		Actor[] targets = { actors[i] };
		String[] methodNames = { "m" };
		Object[][] arguments = { { } };
		int [] tokens = {-1};
		try {
		    actors[i].send
			(Message.createMessage
			 (this,
			  targets,
			  methodNames,
			  arguments,
			  tokens));
		} catch (NoSuchMessageException nsme){
		    System.err.println(nsme);
		    nsme.printStackTrace();
		} catch (MessageCreationException mce){
		    System.err.println("SALSA Internal Error:"+
				       mce.getMessage());
		}   
	    }
	}
	return System.currentTimeMillis() - initialTime;
    }
    public static void main(String[] args){
	StandardOutput standardOutput = new StandardOutput();
	int howMany = Integer.parseInt(args[0]);
	SimpleActor[] actors = new SimpleActor[howMany];
	for (int i = 0; i< howMany; i++){
	    actors[i] = new SimpleActor();
	}
	Multicast director = new Multicast(actors);
//      standardOutput:print("Time for multicast: ") ->
//      director:go() ->
// 	standardOutput:print ->
// 	standardOutput:println(" ms.");
// //         director:go() -> standardOutput:println("Multicast took: "+token+" ms.");
	{
	    Actor[] targets = { standardOutput, director,
	                        standardOutput, standardOutput};
	    String[] methodNames = { "print", "go",
	                             "print", "println"};
	    Object[][] arguments = { { "Time for multicast: " },
				     { },
				     { null },
				     { " ms." }
	    };
	    int [] tokens = {-1, -1, 0, -1};
	    try {
		standardOutput.send
		    (Message.createMessage
		     (director,
		      targets,
		      methodNames,
		      arguments,
		      tokens));
	    } catch (NoSuchMessageException nsme){
		nsme.printStackTrace();
	    } catch (MessageCreationException mce){
		System.err.println("SALSA Internal Error:"+
				   mce.getMessage());
	    }   
	}


    }
}
